
program CDDB_ID_Test;

uses
  SysUtils, MMSystem;

function MSF2Frames(aValue: Integer): Integer;
begin
  Result := mci_MSF_Minute(aValue) * 60 * 75 + mci_MSF_Second(aValue) * 75 + mci_MSF_Frame(aValue);
end;

procedure DoCalcID;
var
  j: Integer;
  T: Integer;
  lP        : tMCI_OPEN_Parms;
  lSP	    : tMCI_STATUS_Parms;
  lSetParms : tMCI_SET_PARMS;
  DevID	    : Integer;
  lErr 	    : mciError;
  lPrevPos  : Integer;
  N         : Integer;
  Sum       : Integer;
  DLen      : Integer;
begin
  // try to open
  lP.lpstrDeviceType := pChar(MCI_DEVTYPE_CD_AUDIO);
  lErr  := mciSendCommand(MCI_DEVTYPE_CD_AUDIO, MCI_OPEN, MCI_WAIT + MCI_OPEN_TYPE + MCI_OPEN_TYPE_ID, Integer(@lP));
  if (lErr = 0) then begin
    DevID := lP.wDeviceID;
    // check if CD inserted
    lSP.dwItem := MCI_STATUS_MEDIA_PRESENT;
    lErr := mciSendCommand(DevID, MCI_STATUS, MCI_WAIT + MCI_STATUS_ITEM, Integer(@lSP));
    if (lErr = 0) and (lSP.dwReturn <> 0) then begin
      Sum        := 0;
      DLen       := 0;
      // try to set MSF format
      lSetParms.dwTimeFormat := MCI_FORMAT_MSF;
      mciSendCommand(DevID, MCI_SET, MCI_WAIT + MCI_SET_TIME_FORMAT, Integer(@LSetParms));
      lSP.dwItem := MCI_STATUS_TIME_FORMAT;
      lErr := mciSendCommand(DevID, MCI_STATUS, MCI_WAIT + MCI_STATUS_ITEM, Integer(@lSP));
      if (lErr = 0) and (lSP.dwReturn = MCI_FORMAT_MSF) then begin
	// get the media length
	lSP.dwItem := MCI_STATUS_LENGTH;
	lErr := mciSendCommand(DevID, MCI_STATUS, MCI_WAIT + MCI_STATUS_ITEM, Integer(@lSP));
	if (lErr = 0) then DLen := MSF2Frames(lSP.dwReturn) div 75;
	WriteLn('Media length: ' + IntToHex(DLen, 4));
	// get the number of tracks
	lSP.dwItem := MCI_STATUS_NUMBER_OF_TRACKS;
	lErr := mciSendCommand(DevID, MCI_STATUS, MCI_WAIT + MCI_STATUS_ITEM, Integer(@lSP));
	if (lErr = 0) then begin
	  T := lSP.dwReturn;
	  lPrevPos := 150;	// default pos
	  if (T > 0) then begin
	    WriteLn('Number of tracks: ' + IntToHex(T, 2) + #13#10);
	    // scan the tracks
	    for j := 1 to T + 1 do begin
	      if (j <= T) then begin
		lSP.dwItem  := MCI_STATUS_POSITION;
		lSP.dwTrack := j;
		lErr := mciSendCommand(DevID, MCI_STATUS, MCI_WAIT + MCI_STATUS_ITEM + MCI_TRACK, Integer(@lSP));
		lSP.dwReturn := MSF2Frames(lSP.dwReturn);
	      end
	      else begin
		lErr := 0;
		lSP.dwReturn := DLen;
	      end;
	      if (lErr = 0) and (j > 1){not for first track} then begin
		// calc the sum
		N := (lPrevPos div 75);	// in seconds
		while (N > 0) do begin
		  Sum := Sum + N mod 10;
		  N := N div 10;
		end;
	      end;
	      lPrevPos := lSP.dwReturn;
	      if (j <= T) then WriteLn('  Track #' + IntToHex(j, 2) + ' offset in frames: ' + IntToStr(lPrevPos));
	    end;
	    WriteLn(#13#10'I suppose CDDB DISCID for this CD is  <' + LowerCase(IntToHex((Sum and $FF) shl 24 + DLen shl 8 + T and $FF, 8)) + '>');
	  end
	  else WriteLn('No tracks!');
	end
	else WriteLn('Unable to obtain number of tracks.');
      end
      else WriteLn('Unable to set MSF format.');
    end
    else WriteLn('No disc in drive.'#13#10'Please insert CD-Audio disc.');
    mciSendCommand(DevID, MCI_CLOSE, MCI_WAIT, 0);
  end {OPEN OK}
  else 
    if (lErr = MCIERR_MUST_USE_SHAREABLE) then WriteLn('Drive is in use.'#13#10'Please close all CD-Players and rerun.')
					  else WriteLn('Unable to open drive as MCI device.');
end;

begin
  WriteLn('CDDB DISCID Caclculator. Debug version by Alek Shamrai, 29 MAY 1998'#13#10);
  DoCalcID;
  WriteLn(#13#10'Done. Please report bugs to <alexsh@adm.univd.kharkov.ua>');
end.

