
unit uMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, ComCtrls, SortedListView, StdCtrls, Buttons, Menus, Mover, TB97, MMSystem,
  LCDate;

type
  pItem = ^tItem;
  tItem = record
    fArtist	: string;
    fTitle 	: string;
    fSerial	: string;
    fTime	: string;
    fYear	: string;
    fMemo	: string;
    fOther	: string;
  end;

  tLibrary = class
  private
    fItems: tList;
    fStream: tFileStream;
  public
    constructor Create;
    destructor Destroy; override;
    //
    function GetItem(aIndex: Integer): pItem;
    //
    procedure FreeItems;
    function  ReadInt: Integer;
    function  ReadStr: string;
    function  ReadStr2(const ID: string): string;
    procedure WriteInt(aInt: Integer);
    procedure WriteStr(const aStr: string);
    procedure WriteStr2(const ID, aStr: string);
    procedure DoLoadFromFile(const aFileName: string);
    procedure DoSaveToFile(const aFileName: string);
    procedure Add(const aArtist, aTitle, aSerial, aTime, aYear, aMemo, aOther: string);
    function  HaveSerial(const aSerial: string): Integer;
    //
    property Item[aIndex: Integer]: pItem read GetItem; default;
  end;

  TForm1 = class(TForm)
    LV: TSortedListView;
    P1: TPanel;
    SB1: TStatusBar;
    OD1: TOpenDialog;
    SD1: TSaveDialog;
    MM1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    Save1: TMenuItem;
    Saveas1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    Edit6: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    Commands1: TMenuItem;
    Produce1: TMenuItem;
    Import1: TMenuItem;
    N2: TMenuItem;
    Import2: TMenuItem;
    ScancurrentCD1: TMenuItem;
    GB1: TGroupBox;
    Label5: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    Label2: TLabel;
    Label1: TLabel;
    E1: TEdit;
    E2: TEdit;
    E3: TEdit;
    E4: TEdit;
    E5: TEdit;
    AddBtn: TButton;
    DeleteBtn: TButton;
    UpdateBtn: TButton;
    Mover1: TMover;
    New1: TMenuItem;
    PM1: TPopupMenu;
    Add1: TMenuItem;
    Delete1: TMenuItem;
    Update1: TMenuItem;
    D1: TDock97;
    MainTB: TToolbar97;
    OpenBtn: TToolbarButton97;
    SaveBtn: TToolbarButton97;
    NewBtn: TToolbarButton97;
    TS1: TToolbarSep97;
    TS2: TToolbarSep97;
    ExitBtn: TToolbarButton97;
    AboutBtn: TToolbarButton97;
    ToolbarButton971: TToolbarButton97;
    ToolbarButton972: TToolbarButton97;
    ToolbarButton973: TToolbarButton97;
    ToolbarButton974: TToolbarButton97;
    IL1: TImageList;
    SBu1: TSpeedButton;
    SBu2: TSpeedButton;
    SBd1: TSpeedButton;
    SBd2: TSpeedButton;
    Eqf: TEdit97;
    TS5: TToolbarSep97;
    Additemsfrom1: TMenuItem;
    Updateitemsfrom1: TMenuItem;
    N3: TMenuItem;
    Updateit1: TMenuItem;
    Updateexistingitemsonly1: TMenuItem;
    E6: TEdit;
    Label6: TLabel;
    Toolbar1: TMenuItem;
    CDTB: TToolbar97;
    ToolbarButton975: TToolbarButton97;
    ToolbarButton976: TToolbarButton97;
    ToolbarButton977: TToolbarButton97;
    ToolbarButton978: TToolbarButton97;
    CDCB: TComboBox;
    ScanBtn: TToolbarButton97;
    TS4: TToolbarSep97;
    TS3: TToolbarSep97;
    Timer1: TTimer;
    ToolbarButton979: TToolbarButton97;
    Statusbar1: TMenuItem;
    CDtoolbar1: TMenuItem;
    SpeedButton1: TSpeedButton;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    M1: TMemo;
    TabSheet2: TTabSheet;
    M_H: TMemo;
    M_B: TMemo;
    M_E: TMemo;
    Mover2: TMover;
    Mover3: TMover;
    SD2: TSaveDialog;
    N4: TMenuItem;
    Up1: TMenuItem;
    LCDate1: TLCDate;
    FD1: TFontDialog;
    N5: TMenuItem;
    Ront1: TMenuItem;
    Detailspanel1: TMenuItem;
    Dock971: TDock97;
    Dock972: TDock97;
    TabSheet3: TTabSheet;
    Panel1: TPanel;
    Label8: TLabel;
    EID: TEdit;
    BRequest: TButton;
    BAbort: TButton;
    MCDDB: TMemo;
    CBProxy: TCheckBox;
    EProxyIP: TEdit;
    EPPort: TEdit;
    Label7: TLabel;
    Display1: TMenuItem;
    TTE: TMenuItem;
    TTR: TMenuItem;
    DTE: TMenuItem;
    DTR: TMenuItem;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure LVChange(Sender: TObject; Item: TListItem;
      Change: TItemChange);
    procedure LVClick(Sender: TObject);
    procedure AddBtnClick(Sender: TObject);
    procedure UpdateBtnClick(Sender: TObject);
    procedure Saveas1Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure ScancurrentCD1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure Produce1Click(Sender: TObject);
    procedure Import1Click(Sender: TObject);
    procedure About1Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure DeleteBtnClick(Sender: TObject);
    procedure Add1Click(Sender: TObject);
    procedure Delete1Click(Sender: TObject);
    procedure Update1Click(Sender: TObject);
    procedure OpenBtnClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure AboutBtnClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure ToolbarButton971Click(Sender: TObject);
    procedure ScanBtnClick(Sender: TObject);
    procedure SBu1Click(Sender: TObject);
    procedure SBu2Click(Sender: TObject);
    procedure SBd2Click(Sender: TObject);
    procedure SBd1Click(Sender: TObject);
    procedure EqfChange(Sender: TObject);
    procedure Additemsfrom1Click(Sender: TObject);
    procedure Updateitemsfrom1Click(Sender: TObject);
    procedure Updateit1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure NewBtnClick(Sender: TObject);
    procedure Toolbar1Click(Sender: TObject);
    procedure Edit6Click(Sender: TObject);
    procedure MainTBDockChanged(Sender: TObject);
    procedure ToolbarButton976Click(Sender: TObject);
    procedure ToolbarButton977Click(Sender: TObject);
    procedure ToolbarButton978Click(Sender: TObject);
    procedure ToolbarButton975Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure ToolbarButton979Click(Sender: TObject);
    procedure Statusbar1Click(Sender: TObject);
    procedure CDtoolbar1Click(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
    procedure M_HChange(Sender: TObject);
    procedure Up1Click(Sender: TObject);
    procedure LVColumnClick(Sender: TObject; Column: TListColumn);
    procedure CDTBRecreating(Sender: TObject);
    procedure CDTBRecreated(Sender: TObject);
    procedure Ront1Click(Sender: TObject);
    procedure Detailspanel1Click(Sender: TObject);
    procedure BRequestClick(Sender: TObject);
    procedure TTEClick(Sender: TObject);
    procedure TTRClick(Sender: TObject);
    procedure DTEClick(Sender: TObject);
    procedure DTRClick(Sender: TObject);
  private
    { Private declarations }
    fLib  : tLibrary;
    fFile : string;
    fFOK  : Boolean;
    fModf2: Boolean;
    mciDeviceID: Integer;
    NoChange: Boolean;
    regToolBarsKey: string;
    CDCBIndex: Integer;
    fDisplay: Integer;
    procedure CopyToLV;
    procedure CopyFromLV;
    procedure Changed;
    procedure SelMoved;
    //function  GetSerialAndUPC(aDevID: Integer; aDisk: Char; out aSerial, aUPC: string): Boolean;
    procedure AssignFile(const aFileName: string; DoLoad: Boolean);
    function  AskChanged: Boolean;
    procedure DoModf;
    function  GoodTrackName(const aName: string): Boolean;
    procedure SetModf(aValue: Boolean);
    procedure ReassignFont;
    procedure MyOnDataBack(Sender: tObject; const aBackData, aErrorStr: string; anError: Integer);
    // DOs
    procedure ReallyDoSave;
    function  DoSaveAs: Boolean;
    function  DoOpen: Boolean;
    function  DoSave: Boolean;
    procedure DoImport(OnlyUpdate: Boolean);
    procedure DoScanCurrent;
    procedure DoProduceHTML;
    procedure DoProduceTXT;
    procedure DoAbout;
    procedure DoAdd;
    procedure DoDel;
    procedure DoUpdate;
    procedure _DoExit;
    procedure DoUpdateCDINI;
    procedure DoNew;
    procedure DoUp;
    //
    procedure DoPlay;
    procedure DoSeek(Delta: Integer);
    procedure DoStop;
    procedure DoPause;
    procedure DoDisplayStatus;
    // mci
    function  mciOpen: Boolean;
    procedure mciClose;
    procedure MMNotify(var Message: tMessage); message MM_MCINOTIFY;
    //
    property Modf: Boolean read fModf2 write SetModf;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses
  HomeTool, CDDB, HTTPTools;

{$R *.DFM}

const
  idLibrary	= $6736;

  regAppName	= 'CDROMer';
  regLibPath	= 'LibPath';
  regHTMLPath	= 'HTMLPath';

  c666		= #6#6#6#6#6;	// at least 5 chars to avoid mismatching with Integer $6666

  { tLibrary }

constructor tLibrary.Create;
begin
  inherited;
  fItems := tList.Create;
end;

destructor tLibrary.Destroy;
begin
  FreeItems;
  fItems.Free;
  inherited;
end;

function tLibrary.GetItem(aIndex: Integer): pItem;
begin
  Result := pItem(fItems[aIndex]);
end;

procedure tLibrary.FreeItems;
var
  i: Integer;
begin
  for i := 0 to fItems.Count - 1 do Dispose(Item[i]);
  fItems.Clear;
end;

function tLibrary.ReadInt: Integer;
begin
  fStream.Read(Result, 4);
end;

function tLibrary.ReadStr: string;
var
  i: Integer;
begin
  fStream.Read(i, 4);
  SetLength(Result, i);
  if (i > 0) then fStream.Read(Result[1], i);
end;

function tLibrary.ReadStr2(const ID: string): string;
var
  lP: Integer;
  lS: string;
begin
  Result := '';
  lP := fStream.Position;
  lS := UpperCase(Trim(ReadStr));
  if (lS = ID) then Result := ReadStr
	       else fStream.Seek(lP, soFromBeginning);
end;

procedure tLibrary.WriteInt(aInt: Integer);
begin
  fStream.Write(aInt, 4);
end;

procedure tLibrary.WriteStr(const aStr: string);
var
  i: Integer;
begin
  i := Length(aStr);
  fStream.Write(i, 4);
  if (i > 0) then fStream.Write(aStr[1], i);
end;

procedure tLibrary.WriteStr2(const ID, aStr: string);
begin
  WriteStr(ID);
  WriteStr(aStr);
end;

procedure tLibrary.DoLoadFromFile(const aFileName: string);
var
  lC: Integer;
  lA, lT, lS, lI, lY, lM, lO: string;
begin
  if FileExists(aFileName) then begin
    FreeItems;
    fStream := tFileStream.Create(aFileName, fmOpenRead + fmShareDenyNone);
    try
      if (ReadInt = idLibrary) then
	for lC := ReadInt downto 1 do begin
	  // order is important!
	  lA := ReadStr2('A');
	  lT := ReadStr2('T');
	  lS := ReadStr2('S');
	  lI := ReadStr2('I');
	  lY := ReadStr2('Y');
	  lM := ReadStr2('M');
	  lO := ReadStr2('O');
	  Add(lA, lT, lS, lI, lY, lM, lO);
	end;
    finally
      fStream.Free;
    end;
  end;
end;

procedure tLibrary.DoSaveToFile(const aFileName: string);
var
  i: Integer;
begin
  fStream := tFileStream.Create(aFileName, fmCreate);
  try
    WriteInt(idLibrary);
    WriteInt(fItems.Count);
    for i := 0 to fItems.Count - 1 do
      with Item[i]^ do begin
	// order is important!
	WriteStr2('A', fArtist);
	WriteStr2('T', fTitle);
	WriteStr2('S', fSerial);
	WriteStr2('I', fTime);
	WriteStr2('Y', fYear);
	WriteStr2('M', fMemo);
	WriteStr2('O', fOther);
      end;
  finally
    fStream.Free;
  end;
end;

procedure tLibrary.Add(const aArtist, aTitle, aSerial, aTime, aYear, aMemo, aOther: string);
var
  lI: pItem;
begin
  New(lI);
  with lI^ do begin
    fArtist := aArtist;
    fTitle  := aTitle;
    fSerial := aSerial;
    fTime   := aTime;
    fYear   := aYear;
    fMemo   := aMemo;
    fOther  := aOther;
  end;
  fItems.Add(lI);
end;

function tLibrary.HaveSerial(const aSerial: string): Integer;
var
  i: Integer;
begin
  Result := -1;
  if (Trim(aSerial) <> '') then
    for i := 0 to fItems.Count - 1 do
      if (Item[i].fSerial = aSerial) then begin
	Result := i;
	Break;
      end;
end;

  { tForm1 }

procedure tForm1.AssignFile(const aFileName: string; DoLoad: Boolean);
var
  lZ: string;
  lK: string;
  lP: Integer;
  lL: Integer;
begin
  fFile := aFileName;
  SD1.InitialDir := ExtractFilePath(fFile);
  OD1.InitialDir := SD1.InitialDir;
  fFOK  := True;
  if DoLoad then begin
    lZ := ReadTextFile(fFile);
    lL := SeekStr(@lZ[1], Length(lZ), c666, False) + 1;
    lP := 1;
    while (lP > 0) do begin
      Inc(lL, Length(c666));
      lP := SeekStr(@lZ[lL], Length(lZ) - lL + 1, c666, False);
      if (lP > 1) then begin
	lK := Copy(lZ, lL, lP);
	if (Pos('M_H:', lK) = 1) then M_H.Text := Copy(lK, 5, Length(lK)) else
	if (Pos('M_B:', lK) = 1) then M_B.Text := Copy(lK, 5, Length(lK)) else
	if (Pos('M_E:', lK) = 1) then M_E.Text := Copy(lK, 5, Length(lK)) else ;
	Inc(lL, lP);
      end;
    end;
    fLib.DoLoadFromFile(fFile);
    CopyToLV;
    SelMoved;
  end;
  SetRegStr(regAppName, regLibPath, aFileName);
  Modf := False;
  Caption := regAppName + ' - ' + aFileName;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  lB: Boolean;
   i: Char;
  DriveType: Integer;
begin
  fDisplay := GetRegInt(regAppName, 'Display', 1);
  case fDisplay of
    1:   TTE.Checked := True;
    2:   TTR.Checked := True;
    3:   DTE.Checked := True;
    else DTR.Checked := True;
  end;
  RegLoadControl(Self, regAppName);
  RegLoadControl(P1, regAppName);
  Mover1.Visible := P1.Visible;
  RegLoadControl(SB1, regAppName);
  SB1.Top := P1.Top + P1.Height + 1;
  RegLoadFont(M1.Font, regAppName + '\BaseFont');
  ReassignFont;
  regToolBarsKey := regRoot + regAppName + '\ToolBars';
  RegLoadToolbarPositions(Self, regToolBarsKey);
  RegLoadSLVsPosition(Self, regAppName);
  fLib  := tLibrary.Create;
  if (ParamCount < 1) then fFile := GetRegStr(regAppName, regLibPath, '')
		      else fFile := ParamStr(1);
  fFile := ExpandFileName(fFile);
  SD2.InitialDir := GetRegStr(regAppName, regHTMLPath, '');
  lB    := (fFile <> '');
  if not lB then fFile := ChangeFileExt(ParamStr(0), '.CDL');
  AssignFile(fFile, True);
  fFOK  := lB;
  Modf  := True;
  Modf  := False;
  CDCB.Items.Clear;
  for i := 'A' to 'Z' do begin
    DriveType := GetDriveType(PChar(i + ':\'));
    if (DriveType = DRIVE_CDROM) then CDCB.Items.Add(i + ':');
  end;
  if (CDCB.Items.Count < 1) then begin
    CDTB.Visible := False;
    ScanCurrentCD1.Enabled := False;
  end
  else CDCB.ItemIndex := 0;
  mciDeviceID := -1; 	// start the timer
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  RegSaveControl(Self, regAppName);
  RegSaveControl(P1, regAppName);
  RegSaveControl(Sb1, regAppName);
  RegSaveFont(M1.Font, regAppName + '\BaseFont');
  RegSaveToolbarPositions(Self, regToolBarsKey);
  RegSaveSLVsPosition(Self, regAppName);
  SetRegInt(regAppName, 'Display', fDisplay); 
  fLib.Free;
end;

procedure tForm1.CopyToLV;
var
   i: Integer;
  lI: pItem;
begin
  LV.Items.Clear;
  for i := 0 to fLib.fItems.Count - 1 do begin
    lI := fLib[i];
    with LV.Items.Add do begin
      Caption := lI.fArtist;
      SubItems.Add(lI.fTitle);
      SubItems.Add(lI.fSerial);
      SubItems.Add(lI.fTime);
      SubItems.Add(lI.fYear);
      SubItems.Add(lI.fMemo);
      SubItems.Add(lI.fOther);
      DoModf;
    end;
  end;
end;

procedure tForm1.CopyFromLV;
var
  i : Integer;
  lS: tStrings;
begin
  fLib.FreeItems;
  for i := 0 to LV.Items.Count - 1 do begin
    lS := lV.Items[i].SubItems;
    fLib.Add(lV.Items[i].Caption, lS[0], lS[1], lS[2], lS[3], lS[4], lS[5]);
  end;
end;

procedure tForm1.Changed;
begin
  //CopyFromLV;
  SelMoved;
end;

procedure tForm1.SelMoved;
var
  lS: tStrings;
begin
  if Assigned(LV.Selected) then begin
    E1.Text := LV.Selected.Caption;
    lS := lV.Selected.SubItems;
    E2.Text := lS[0];
    E3.Text := lS[1];
    E4.Text := lS[2];
    E5.Text := lS[3];
    M1.Text := lS[4];
    E6.Text := lS[5];
  end
  else begin
    E1.Text := '';
    E2.Text := '';
    E3.Text := '';
    E4.Text := '';
    E5.Text := '';
    M1.Text := '';
    E6.Text := '';
  end;
end;

procedure TForm1.LVChange(Sender: TObject; Item: TListItem; Change: TItemChange);
begin
  if not NoChange then Changed;
end;

procedure TForm1.LVClick(Sender: TObject);
begin
  SelMoved;
end;

procedure TForm1.DoAdd;
begin
  with LV.Items.Add do begin
    Caption := 'New artist';
    SubItems.Add('New album');
    SubItems.Add('0000-0000');
    SubItems.Add('44:56');
    SubItems.Add('1998');
    SubItems.Add('Track 1'#13#10'Track 2');
    SubItems.Add('Other info');
  end;
  lV.Selected := lV.Items[lV.Items.Count - 1];
  DoModf;
end;

procedure TForm1.AddBtnClick(Sender: TObject);
begin
  DoAdd;
end;

procedure tForm1.DoUpdate;
var
  lS: tStrings;
begin
  if Assigned(lV.Selected) then begin
    NoChange := True;
    lV.Selected.Caption := E1.Text;
    lS := lV.Selected.SubItems;
    lS[0] := E2.Text;
    lS[1] := E3.Text;
    lS[2] := E4.Text;
    lS[3] := E5.Text;
    lS[4] := M1.Text;
    lS[5] := E6.Text;
    NoChange := False;
    DoModf;
  end;
end;

procedure TForm1.UpdateBtnClick(Sender: TObject);
begin
  DoUpdate;
end;

procedure tForm1.ReallyDoSave;
begin
  CopyFromLV;
  fLib.DoSaveToFile(fFile);
  // and save HTML
  AddTextToFile(fFile, c666 + 'M_H:' + M_H.Text + c666 + 'M_B:' + M_B.Text + c666 + 'M_E:' + M_E.Text + c666, False);
end;

function tForm1.DoSaveAs: Boolean;
begin
  Result := SD1.Execute;
  if Result then begin
    CopyFromLV;
    AssignFile(SD1.FileName, False);
    ReallyDoSave;
  end;
end;

function tForm1.AskChanged: Boolean;
begin
  Result := True;
  if Modf then
    case AskYNC('Save changes?') of
      mrYes	: Result := DoSave;
      mrCancel	: Result := False;
    end;  
end;

function tForm1.DoOpen: Boolean;
begin
  Result := AskChanged and OD1.Execute;
  if Result then AssignFile(OD1.FileName, True);
end;

function tForm1.DoSave: Boolean;
begin
  Result := True;
  //CopyFromLV;
  if fFOK then ReallyDoSave
	  else Result := DoSaveAs;
  if Result then Modf := False;
end;

function ToSerial(const aStr: string): string;
begin
  Result := '0000' + Copy(aStr, Length(aStr) - 3, 4);
  Result := '0000' + Copy(aStr, 1, Length(aStr) - 4) + '-' + Copy(Result, Length(Result) - 3, 4);
  Result := Copy(Result, Length(Result) - 8, 9);
end;

function GetCDINI: string;
var
  lA: array[0..MAX_PATH] of Char;	// one char is for spare :)
begin
  if (GetEnvironmentVariable('WINDIR', lA, MAX_PATH) > 0) then Result := lA + '\CDPLAYER.INI'
  else begin
    ShowMessage('%WINDIR% unavailable!');
    Result := '';
  end;
end;

function MyToday: string;
const
  MNTH: array[1..12] of string = ('JAN', 'FEB', 'MAR', 'APR', 'MAY', 'JUN', 'JUL', 'AUG', 'SEP', 'OCT', 'NOV', 'DEC');
var
  D, M, Y: Word;
begin
  DecodeDate(Date, Y, M, D);
  Result := IntToStr(D) + ' ' + MNTH[M] + ' ' + IntToStr(Y);
  if (D < 10) then Result := '0' + Result; 
end;

procedure tForm1.DoImport(OnlyUpdate: Boolean);
var
   i: Integer;
  lI: pItem;

  procedure NewLI;
  begin
    New(lI);
    lI.fSerial := '';
    lI.fTime   := '45:00';
    lI.fYear   := '1998';
    lI.fOther  := MyToday;
  end;

  procedure AddLI;
  var
    i: Integer;
    p: pItem;
    LS: tStrings;
    lZ: tStrings;
    lO: string;
    lM: string;
    lK: Integer;
  begin
    lI.fMemo := Trim(lI.fMemo);
    i := fLib.HaveSerial(lI.fSerial);
    if Assigned(lI) then
      if (i < 0) then
	if OnlyUpdate then Dispose(lI)
		      else fLib.fItems.Add(lI)
      else begin
	p := fLib[i];
	p.fArtist := lI.fArtist;
	P.fTitle  := lI.fTitle;
	lS := tStringList.Create;
	lZ := tStringList.Create;
	try
	  lS.Text := lI.fMemo;
	  lZ.Text := P.fMemo;
	  for i := 0 to lS.Count - 1 do begin
	    lO := lS[i];
	    if (lZ.Count > i) then begin
	      lM := lZ[i];
	      lK := Length(lM);
	      if (lM[lK] = ')') then begin
		Dec(lK);
		while (lK > 0) and (lM[lK] in ['0'..'9', ':']) do Dec(lK);
		if (lK > 0) and (lM[lK] = '(') then lO := lO + ' ' + Copy(lM, lK, Length(lM));
	      end;
	    end
	    else lZ.Add('');
	    lZ[i] := lO;
	  end;
	  p.fMemo := lZ.Text;
	finally
	  lS.Free;
	  lZ.Free;
	end;
	Dispose(lI);
      end;
  end;

var
  lS: string;
begin
  CopyFromLV;
  with tStringList.Create do try;
    if (GetCDINI <> '') then begin
      LoadFromFile(GetCDINI);
      NewlI;
      for i := 0 to Count - 1 do begin
	lS := Trim(Strings[i]);
	if (lS <> '') then
	  if (Pos('[', lS) = 1) then begin
	    AddLI;
	    NewlI;
	    lI.fSerial := ToSerial(Copy(lS, 2, Length(lS) - 2));
	  end else
	  if (Pos('ARTIST=', UpperCase(lS)) = 1) then lI.fArtist := Copy(lS, 8, Length(lS)) else
	  if (Pos('TITLE=', UpperCase(lS)) = 1)  then lI.fTitle  := Copy(lS, 7, Length(lS)) else
	  if (Pos('=', lS) = 2) then lI.fMemo := lI.fMemo + #13#10 + Copy(lS, 3, Length(lS)) else
	  if (Pos('=', lS) = 3) then lI.fMemo := lI.fMemo + #13#10 + Copy(lS, 4, Length(lS)) else
	  if (Pos('=', lS) = 4) then lI.fMemo := lI.fMemo + #13#10 + Copy(lS, 5, Length(lS));
      end;
      AddLI;
    end;
  finally
    Free;
  end;
  CopyToLV;
end;

function Int2Str(a: Integer): string;
begin
  Result := IntToStr(a);
  if (Length(Result) < 2) then Result := '0' + Result;
end;

function Frames2Str(msf: Integer): string;
var
  lSec: Integer;
begin
  lSec := msf div 75;
  Result := Int2Str(lSec div 60) + ':' + Int2Str(lSec mod 60);
end;

(*
function tForm1.GetSerialAndUPC(aDevID: Integer; aDisk: Char; out aSerial, aUPC: string): Boolean;
var
  lIP	     : tMCI_INFO_Parms;
  lSerial    : DWord;
  DirLen     : DWord;
  FileSys    : array[0..12] of Char;
  DLabel     : array[0..12] of Char;
  SystemFlags: DWord;
  lErr 	     : mciError;
begin
  // obtain serial number & UPC
  GetMem(lIP.lpstrReturn, 256);
  try
    lIP.dwRetSize := 255;
    lErr := mciSendCommand(aDevID, MCI_INFO, MCI_WAIT + MCI_INFO_MEDIA_UPC, Integer(@lIP));
    if (lErr = 0) then aUPC := lIP.lpstrReturn
		  else aUPC := '';
    lErr := mciSendCommand(aDevID, MCI_INFO, MCI_WAIT + MCI_INFO_MEDIA_IDENTITY, Integer(@lIP));
    if (lErr = 0) then aSerial := IntToHex(StrToInt(lIP.lpstrReturn), 8)
    else begin
      // other way
      if GetVolumeInformation(PChar(aDisk + ':\'), @DLabel, 12, @lSerial, DirLen, SystemFlags, @FileSys, 12) then lErr := 0
													     else lErr := 1;
      if (lErr = 0) then aSerial := IntToHex(lSerial, 8);
    end;
    if (lErr = 0) then begin
      Insert('-', aSerial, 5);
      Result := True;
    end
    else Result := False;
  finally
    FreeMem(lIP.lpstrReturn, 256);
  end;
end;
*)

function MSF2Frames(aValue: Integer): Integer;
begin
  Result := mci_MSF_Minute(aValue) * 60 * 75 + mci_MSF_Second(aValue) * 75 + mci_MSF_Frame(aValue);
end;

function cdError2Str(anError: Integer): string;
begin
  case anError of
    cddbOK			: Result := 'No error';
    cddbDriveInUse		: Result := 'Drive is in use';
    cddbUnableToOpen		: Result := 'Unable to open mci device';
    cddbMSFFormatUnavailable	: Result := 'MSF format unavailable';
    cddbNoDiscInDrive		: Result := 'No disc in drive';
    cddbNoTracks		: Result := 'No tracks!';
    cddbUnableToGetTracks	: Result := 'Unable to get tracks info';
    else			  Result := 'Unknown error'
  end;
end;

procedure tForm1.DoScanCurrent;
var
  lS      : string;
  lCh     : Boolean;
  Time    : string;
  Album   : string;
  Tracks  : string;
  lCDError: Integer;
  lParams : tCDParams;
  j       : Integer;
  P       : pItem;
  lTT     : string;
begin
  if (CDCB.Items.Count > 0) then begin
    if (CDCB.ItemIndex < 0) then CDCB.ItemIndex := 0;
    lCDError := GetCDParams(CDCB.ItemIndex, lParams);
    if (lCDError = cddbOK) then begin
      CopyFromLV;
      lCh    := False;
      P      := nil;
      Album  := 'New album';
      Tracks := '';
      if (lParams.UPC <> '') then ShowMessage('Universal product code: ' + lParams.UPC);
      j := fLib.HaveSerial(lParams.Serial);
      if (j >= 0) then P := fLib[j];
      Time := Frames2Str(lParams.TrackOffs[lParams.TrackCount]);
      if Assigned(P) then
	if (Pos(Time, P.fTime) <> 1) then begin
	  P.fTime := Time;
	  lCh := True;
	end;
      for j := 0 to lParams.TrackCount - 1 do begin
	lTT := Frames2Str(lParams.TrackOffs[j + 1] - lParams.TrackOffs[j]);
	if Assigned(P) then
	  with tStringList.Create do try
	    Text := P.fMemo;
	    if (Count >= j) then begin
	      lS := Strings[j];
	      if not GoodTrackName(lS) then begin
		Strings[j] := lS + ' (' + lTT + ')';
		lCh := True;
	      end;
	    end
	    else begin
	      Add('Track ' + IntToStr(j + 1) + ' (' + lTT + ')');
	      lCh := True;
	    end;
	    if lCh then P.fMemo := Text;
	  finally
	    Free;
	  end;
	Tracks := Tracks + #13#10 + 'Track ' + IntToStr(j + 1) + ' (' + lTT + ')';
      end;
      // show CDDB id
      EID.Text := CalcCDDBDiscID(lParams);
      // apply changes (if any)
      if not Assigned(P) then begin
	fLib.Add('New artist', Album, lParams.Serial, Time, '1998', Trim(Tracks), MyToday);
	lCh := True;
      end;
      if lCh then begin
	CopyToLV;
	if Assigned(P) then LV.Selected := LV.Items[fLib.HaveSerial(P.fSerial)]
		       else LV.Selected := LV.Items[LV.Items.Count - 1];
	LV.Selected.MakeVisible(False);
      end
      else
	if Assigned(P) then begin
	  LV.Selected := LV.Items[fLib.HaveSerial(P.fSerial)];
	  LV.Selected.MakeVisible(False);
	end;
    end
    else ShowMessage('Error: ' + CDError2Str(lCDError) + '.')
  end
  else ShowMessage('No CD-ROM drive found.');
end;

procedure tForm1.DoProduceHTML;
var
   i: Integer;
  lS: string;
  lL: tStrings;
begin
  if SD2.Execute then begin
    CopyFromLV;
    lL := tStringList.Create;
    lL.Add('TODAY=' + DateToStr(Date));
    lS := ParseString(M_H.Text, '%', lL);
    try
      for i := 0 to fLib.fItems.Count - 1 do begin
	with lL do begin
	  Clear;
	  Add('ARTIST=' + fLib[i].fArtist);
	  Add('TITLE=' + fLib[i].fTitle);
	  Add('SERIAL=' + fLib[i].fSerial);
	  Add('TIME=' + fLib[i].fTime);
	  Add('YEAR=' + fLib[i].fYear);
	  Add('MEMO=' + fLib[i].fMemo);
	  Add('OTHER=' + fLib[i].fOther);
	  Add('TODAY=' + DateToStr(Date));
	end;
	lS := lS + ParseString(M_B.Text, '%', lL);
      end;
    finally
      lS := lS + ParseString(M_E.Text, '%', lL);
      lL.Free;
    end;
    FileClose(FileCreate(SD2.FileName));
    AddTextToFile(SD2.FileName, lS, False);
    SetRegStr(regAppName, regHTMLPath, ExtractFilePath(SD2.FileName));
  end;
end;

procedure tForm1.DoProduceTXT;
begin
  ShowMessage('Not now');
end;

procedure tForm1.DoAbout;
begin
  ShowMessage('CDROMer Ver 0.2.4a by Alek Shamrai (alexsh@adm.univd.kharkov.ua)'#13#10'Toolbar97 version 1.63 by Jordan Russell (email: jordanr7@aol.com)'#13#10'Last compiled: ' + Date2Str(LCDate1.LCDate));
end;

procedure TForm1.Saveas1Click(Sender: TObject);
begin
  DoSaveAs;
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
  DoOpen;
end;

procedure TForm1.Save1Click(Sender: TObject);
begin
  DoSave;
end;

procedure TForm1.ScancurrentCD1Click(Sender: TObject);
begin
  DoScanCurrent;
end;

procedure TForm1.Exit1Click(Sender: TObject);
begin
  _DoExit;
end;

procedure TForm1.Produce1Click(Sender: TObject);
begin
  DoProduceHTML;
end;

procedure TForm1.Import1Click(Sender: TObject);
begin
  DoProduceTXT;
end;

procedure TForm1.About1Click(Sender: TObject);
begin
  DoAbout;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  CanClose := AskChanged;
end;

procedure tForm1.DoDel;
var
  i: Integer;
begin
  if AskYN('Delete this one?') then begin
    if Assigned(LV.Selected) then begin
      i := LV.Selected.Index;
      lV.Items.Delete(i);
      if (i < LV.Items.Count) then LV.Selected := LV.Items[i];
    end;
    DoModf;
  end;
end;

procedure tForm1._DoExit;
begin
  Close;
end;

procedure TForm1.DeleteBtnClick(Sender: TObject);
begin
  DoDel;
end;

procedure tForm1.DoModf;
begin
  Modf := True;
  SB1.Panels[0].Text := IntToStr(fLib.fItems.Count);
  if Assigned(LV.Selected) then LV.Selected.MakeVisible(False);
end;

procedure tForm1.DoNew;
begin
  fFOK := False;
  LV.Items.Clear;
  Modf := True;
end;  

procedure TForm1.Add1Click(Sender: TObject);
begin
  DoAdd;
end;

procedure TForm1.Delete1Click(Sender: TObject);
begin
  DoDel;
end;

procedure TForm1.Update1Click(Sender: TObject);
begin
  DoUpdate;
end;

procedure TForm1.OpenBtnClick(Sender: TObject);
begin
  DoOpen;
end;

procedure TForm1.SaveBtnClick(Sender: TObject);
begin
  DoSave;
end;

procedure TForm1.AboutBtnClick(Sender: TObject);
begin
  DoAbout;
end;

procedure TForm1.ExitBtnClick(Sender: TObject);
begin
  _DoExit;
end;

procedure TForm1.ToolbarButton971Click(Sender: TObject);
const
  lvStyles: array[1..4] of tViewStyle =
    (vsReport, vsList, vsSmallIcon, vsIcon);
begin
  LV.ViewStyle := lvStyles[tControl(Sender).Tag];
end;

procedure TForm1.ScanBtnClick(Sender: TObject);
begin
  if (mciDeviceID < 0) then DoScanCurrent
                       else ShowMessage('Oops. Not now.');
end;

procedure TForm1.SBu1Click(Sender: TObject);
begin
  E1.Text := AnsiUpperCase(E1.Text);
end;

procedure TForm1.SBu2Click(Sender: TObject);
begin
  E2.Text := AnsiUpperCase(E2.Text);
end;

procedure TForm1.SBd2Click(Sender: TObject);
var
  lS: string;
   i: Integer;
begin
  lS := AnsiLowerCase(E2.Text);
  if (lS <> '') then begin
    lS[1] := AnsiUpperCase(lS[1])[1];
    for i := 2 to Length(lS) do
      if (lS[i] in ['a'..'z']) and (lS[i - 1] in [' ', '-', '(']) then lS[i] := AnsiUpperCase(lS[i])[1];
    E2.Text := lS;
  end;
end;

procedure TForm1.SBd1Click(Sender: TObject);
begin
  E1.Text := AnsiLowerCase(E1.Text);
end;

procedure TForm1.EqfChange(Sender: TObject);
var
   i: Integer;
  Li: tListItem;
begin
  for i := 0 to LV.Items.Count - 1 do begin
    Li := LV.Items[i];
    if (Pos(AnsiUpperCase(Eqf.Text), Li.Caption) = 1) then begin
      LV.Selected := Li;
      Li.MakeVisible(False);
      Break;
    end;
  end;
end;

procedure TForm1.Additemsfrom1Click(Sender: TObject);
begin
  DoImport(False);
end;

procedure TForm1.Updateitemsfrom1Click(Sender: TObject);
begin
  DoImport(True);
end;

procedure tForm1.DoUpdateCDINI;
var
  i: Integer;
  P: pItem;
  S: string;
  O: string;
  j: Integer;
  k: tList;
  Z: tStrings;
//  L: Integer;
  T: Integer;
begin
  // update items in CDPLAYER.INI
  Z := nil;
  K := nil;
  with tStringList.Create do try
    Z := tStringList.Create;
    K := tList.Create;
    if (GetCDINI <> '') then begin
      LoadFromFile(GetCDINI);
      CopyFromLV;
      O := '';
      T := 0;
      for i := 0 to fLib.fItems.Count - 1 do begin
	P := fLib[i];
	S := Copy(P.fSerial, 1, 4) + Copy(P.fSerial, 6, 4);
	while (S <> '') and (S[1] = '0') do System.Delete(S, 1, 1);
	//if (S = '') then S := '0';	:) I wander what Microsoft will do with serial 0000-0000?
	if (Pos('[' + S + ']', Text) < 1) then begin
	  K.Clear;
	  Inc(T);
	  O := O + #13#10'[' + S + ']'#13#10'EntryType=1'#13#10'artist=' + P.fArtist + #13#10 +
	       'title=' + P.fTitle;
	  Z.Text := P.fMemo;
	  for j := 0 to Z.Count - 1 do begin
	    S := Trim(Z[j]);
	    //L := Length(S);
	    if {(L > 3) and (S[L] = ')') and (S[L-3] = ':')}GoodTrackName(S) then begin
	      O := O + #13#10 + IntToStr(K.Count) + '=' + S;
	      K.Add(Pointer(j));
	    end;
	  end;
	  if (k.Count > 0) then begin
	    O := O + #13#10 + 'numtracks=' + IntToStr(k.Count) + #13#10'order=';
	    for j := 0 to k.Count - 1 do O := O + IntToStr(j) + ' ';
	    O := O + #13#10'numplay=' + IntToStr(k.Count);
	  end;
	  O := O + #13#10;
	end;
      end;
      if (O <> '') then begin
	Text := Text + O;
	SaveToFile(GetCDINI);
	if (T > 1) then S := 's'
		   else S := '';
	ShowMessage('Added new ' + IntToStr(T) + ' item' + S + '.');
      end
      else ShowMessage('Nothing to add! (All items already exists)');
    end;
  finally
    Free;
    Z.Free;
    K.Free;
  end;
end;

procedure TForm1.Updateit1Click(Sender: TObject);
begin
  DoUpdateCDINI;
end;

procedure TForm1.New1Click(Sender: TObject);
begin
  DoNew;
end;

procedure TForm1.NewBtnClick(Sender: TObject);
begin
  DoNew;
end;

procedure TForm1.SetModf;
const
  PT: array[Boolean] of string = ('', 'Modified');
begin
  if (fModf2 <> aValue) then begin
    fModf2 := aValue;
    SB1.Panels[1].Text := PT[fModf2];
  end;
end;

procedure TForm1.Toolbar1Click(Sender: TObject);
begin
  MainTB.Visible := not MainTB.Visible;
end;

procedure TForm1.Edit6Click(Sender: TObject);
begin
  Toolbar1.Checked := MainTB.Visible;
  Statusbar1.Checked := SB1.Visible;
  CDToolbar1.Checked := CDTB.Visible;
  DetailsPanel1.Checked := P1.Visible;
end;

procedure TForm1.MainTBDockChanged(Sender: TObject);
begin
  if Assigned(CDCB) and (CDCB.Items.Count > 0) and (CDCB.ItemIndex < 0) then CDCB.ItemIndex := 0;
end;

function tForm1.mciOpen: Boolean;
var
  lP: tMCI_OPEN_Parms;
  lErr: Integer;
begin
  lP.lpstrDeviceType := pChar(MCI_DEVTYPE_CD_AUDIO + CDCB.ItemIndex shl 16);
  lErr  := mciSendCommand(MCI_DEVTYPE_CD_AUDIO, MCI_OPEN, MCI_WAIT + MCI_OPEN_TYPE + MCI_OPEN_TYPE_ID, Integer(@lP));
  Result := (lErr = 0);
  if Result then begin
    mciDeviceID := lP.wDeviceID;
    //SB1.Panels[2].Text := '';
  end
  else
    if (lErr = MCIERR_MUST_USE_SHAREABLE) then SB1.Panels[2].Text := 'Drive is in use.'
					  else SB1.Panels[2].Text := 'Unable to open mci device.';
end;

procedure tForm1.mciClose;
begin
  mciSendCommand(mciDeviceID, MCI_CLOSE, MCI_WAIT, 0);
  mciDeviceID := -1;
  DoDisplayStatus;
end;

procedure tForm1.DoPlay;
var
  lPP: tMCI_PLAY_Parms;
begin
  lPP.dwCallback := Handle;
  mciSendCommand(mciDeviceID, MCI_PLAY, MCI_NOTIFY, Integer(@lPP));
end;

procedure TForm1.ToolbarButton976Click(Sender: TObject);
begin
  if mciOpen then try
    DoPlay;
  finally
    mciClose;
  end;
end;

procedure tForm1.MMNotify(var Message: tMessage);
begin
end;

procedure tForm1.DoSeek(Delta: Integer);
var
  lSA: tMCI_SET_PARMS;
  lSS: tMCI_STATUS_PARMS;
  lPP: tMCI_SEEK_PARMS;
  lPA: tMCI_PLAY_Parms;
  lEr: Integer;
//  lT : Integer;
begin
  lSA.dwTimeFormat := MCI_FORMAT_TMSF;
  lEr := mciSendCommand(mciDeviceID, MCI_SET, MCI_WAIT + MCI_SET_TIME_FORMAT, Integer(@lSA));
  if (lEr = 0) then begin
    lSS.dwItem := MCI_STATUS_CURRENT_TRACK;
    lEr := mciSendCommand(mciDeviceID, MCI_STATUS, MCI_WAIT + MCI_STATUS_ITEM, Integer(@lSS));
    if (lEr = 0) then begin
      lPP.dwCallback := Handle;
      lPP.dwTo       := mci_Make_TMSF(mci_TMSF_Track(lSS.dwReturn) + Delta, 0, 0, 0);
      lEr := mciSendCommand(mciDeviceID, MCI_SEEK, MCI_NOTIFY + MCI_TO, Integer(@lPP));
      if (lEr = 0) then begin
	lPA.dwCallback := Handle;
	mciSendCommand(mciDeviceID, MCI_PLAY, MCI_NOTIFY, Integer(@lPA));
      end;
    end;
  end;
end;

procedure TForm1.ToolbarButton977Click(Sender: TObject);
begin
  if mciOpen then try
    DoSeek(-1);
  finally
    mciClose;
  end;
end;

procedure TForm1.ToolbarButton978Click(Sender: TObject);
begin
  if mciOpen then try
    DoSeek(1);
  finally
    mciClose;
  end;
end;

procedure tForm1.DoStop;
begin
  mciSendCommand(mciDeviceID, MCI_STOP, MCI_WAIT, 0);
end;

procedure TForm1.ToolbarButton975Click(Sender: TObject);
begin
  if mciOpen then try
    DoStop;
  finally
    mciClose;
  end;
end;

function tForm1.GoodTrackName(const aName: string): Boolean;
var
  i: Integer;
  Z: string;
  N: Boolean;
begin
  Result := False;
  Z := Trim(aName);
  if (Z <> '') and (Z[Length(Z)] = ')') then begin
    i := Length(Z);
    N := False;
    while (i > 1) and (Z[i] <> ':') do begin
      if (Z[i] in ['0'..'9']) then N := True;
      Dec(i);
    end;
    if (i > 1) and N{at leat must be one digit} then begin
      N := False;
      while (i >= 1) and (Z[i] <> '(') do begin
	if (Z[i] in ['0'..'9']) then N := True;
	Dec(i);
      end;
      Result := (i >= 1) and N;
    end;
  end;
end;

procedure tForm1.DoDisplayStatus;
var
  lParams: tCDParams;
  lCDErr : Integer;
  lStat  : string;
  i      : Integer;
  lTc    : Integer;
  lSt    : string;
  lP1    : Integer;
begin
  if (CDCB.Items.Count > 0) then begin
    if (CDCB.ItemIndex < 0) then CDCB.ItemIndex := 0;
    lCDErr := GetCDParams(CDCB.ItemIndex, lParams);
    if (lCDErr = cddbOK) then begin
      lTc := 0;
      if (lParams.Track > 0) then begin
	i   := fLib.HaveSerial(lParams.Serial);
	if (i >= 0) then
	  with tStringList.Create do try
	    Text := fLib[i].fMemo;
	    for i := 0 to Count - 1 do begin
	      lSt := Strings[i];
	      if GoodTrackName(lSt) then Inc(lTc);
	      if (lTc = lParams.Track) then Break;
	    end;
	    if (lTc <> lParams.Track) then lSt := 'Track ' + IntToStr(lParams.Track);
	  finally
	    Free;
	  end;
      end
      else lSt := '<In the beginning of disc>';
      lP1 := lParams.Position;
      case fDisplay of
	1: if (lParams.Track > 0) then lP1 := lP1 - lParams.TrackOffs[lParams.Track - 1]
	                          else lP1 := 0;
	2: lP1 := lParams.TrackOffs[lParams.Track] - lP1;
	3: lP1 := lP1 - lParams.TrackOffs[0];
	4: lP1 := lParams.TrackOffs[lParams.TrackCount] - lP1;
      end;	
      lStat := Format('Track %d - %s / %s', [lParams.Track, Frames2Str(lP1), lSt]);
    end
    else lStat := CDError2Str(lCDErr)
  end
  else lStat := 'No CD-ROM drive found.';
  SB1.Panels[2].Text := lStat;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
  if (CDCB.Items.Count > 0) and (mciDeviceID < 0) then DoDisplayStatus;
end;

procedure tForm1.DoPause;
begin
  mciSendCommand(mciDeviceID, MCI_PAUSE, MCI_WAIT, 0);
end;

procedure TForm1.ToolbarButton979Click(Sender: TObject);
begin
  if mciOpen then try
    DoPause;
  finally
    mciClose;
  end;
end;

procedure TForm1.Statusbar1Click(Sender: TObject);
begin
  SB1.Visible := not SB1.Visible;
end;

procedure TForm1.CDtoolbar1Click(Sender: TObject);
begin
  CDTB.Visible := not CDTB.Visible;
end;

procedure TForm1.SpeedButton1Click(Sender: TObject);
begin
  E6.Text := MyToday;
end;

procedure TForm1.M_HChange(Sender: TObject);
begin
  Modf := True;
end;

procedure tForm1.DoUp;
var
  lI: Integer;
begin
  if Assigned(LV.Selected) and (LV.Selected.Index > 0) then begin
    lI := LV.Selected.Index - 1;
    with LV.Items.Insert(lI) do Assign(LV.Selected);
    LV.Items.Delete(LV.Selected.Index);
    lV.Selected := LV.Items[lI];
    Modf := True;
  end;  
end;

procedure TForm1.Up1Click(Sender: TObject);
begin
  DoUp;
end;

procedure TForm1.LVColumnClick(Sender: TObject; Column: TListColumn);
begin
  Modf := True;
end;

procedure TForm1.CDTBRecreating(Sender: TObject);
begin
  CDCBIndex := CDCB.ItemIndex;
end;

procedure TForm1.CDTBRecreated(Sender: TObject);
begin
  CDCB.ItemIndex := CDCBIndex;
end;

procedure tForm1.ReassignFont;
begin
  FD1.Font.Assign(M1.Font);
  //M1.Font.Assign(FontDialog1.Font);
  LV.Font.Assign(FD1.Font);
  E1.Font.Assign(FD1.Font);
  E2.Font.Assign(FD1.Font);
  E3.Font.Assign(FD1.Font);
  E4.Font.Assign(FD1.Font);
  E5.Font.Assign(FD1.Font);
  E6.Font.Assign(FD1.Font);
  M_H.Font.Assign(FD1.Font);
  M_B.Font.Assign(FD1.Font);
  M_E.Font.Assign(FD1.Font);
  Eqf.Font.Assign(FD1.Font);
end;

procedure TForm1.Ront1Click(Sender: TObject);
begin
  if FD1.Execute then begin
    M1.Font.Assign(FD1.Font);
    ReassignFont;
  end;
end;

procedure TForm1.Detailspanel1Click(Sender: TObject);
begin
  Mover1.Visible := not P1.Visible;
  P1.Visible := not P1.Visible;
  SB1.Top := P1.Top + P1.Height + 1;
end;

procedure tForm1.MyOnDataBack(Sender: tObject; const aBackData, aErrorStr: string; anError: Integer);
var
   i: Integer;
  lS: string;
begin
  BRequest.Enabled := True;
  BAbort.Enabled := False;
  if (anError = 0) then begin
    lS := '';
    for i := 1 to Length(aBackData) do
      case aBackData[i] of
	#10: lS := lS + #13#10;
	#13: ;	// skip all #13
	else lS := lS + aBackData[i];
      end;
    MCDDB.Text := lS;
  end
  else MCDDB.Text := aErrorStr;
end;

procedure TForm1.BRequestClick(Sender: TObject);
var
  lAddr: string;
  lPort: string;
begin
  BRequest.Enabled := False;
  BAbort.Enabled := True;
  if CBProxy.Checked then begin
    lAddr := EProxyIP.Text;
    lPort := EPPort.Text;
  end
  else begin
    lAddr := 'www.cddb.com';
    lPort := '80';
  end;
  TCPTimeOut := 1200; 
  HTTPSendGetData(lAddr, lPort, 'GET http://cddb.cddb.com:80/~cddb/cddb.cgi?cmd=cddb+read+rock+' + EID.Text + '&hello=ALEXSH+adm.univd.kharkov.ua+CDROMer+0.2.4b&proto=3 HTTP/1.0'#13#10#13#10#13#10, MyOnDataBack);
//  HTTPSendGetData(lAddr, lPort, 'GET http://www.kharkov.ua HTTP/1.0'#13#10#13#10, MyOnDataBack);
end;

procedure TForm1.TTEClick(Sender: TObject);
begin
  TTE.Checked := True;
  fDisplay := 1;
end;

procedure TForm1.TTRClick(Sender: TObject);
begin
  TTR.Checked := True;
  fDisplay := 2;
end;

procedure TForm1.DTEClick(Sender: TObject);
begin
  DTE.Checked := True;
  fDisplay := 3;
end;

procedure TForm1.DTRClick(Sender: TObject);
begin
  DTR.Checked := True;
  fDisplay := 4;
end;

end.

